libmwaw Namespace Reference

namespace used to regroup all libwpd functions, enumerations which we have redefined for internal usage More...

## Namespaces

namespace | Debug
| debugging tools

## Classes

class | VersionException
class | FileException
class | ParseException
class | GenericException
class | WrongPasswordException
class | DebugFile
struct | PrinterRectResolution
| Internal: structure used to keep a rectangle with its resolution. More...
struct | PrinterStyle
| Internal: structure used to keep the printer style information. More...
struct | PrinterJob
| Internal: structure used to keep a printer job. More...
struct | PrinterInfoData
| internal structure used to keep TPrint content More...
struct | PrinterRect
| the AppleŠ rectangle : Rect More...
struct | PrinterInfo
| the AppleŠ printer information : TPrint More...

## Typedefs

typedef std::stringstream | DebugStream
| a basic stream (if debug_with_files is not defined, does nothing)

## Enumerations

enum | Position { Left = 0 , Right = 1 , Top = 2 , Bottom = 3 , HMiddle = 4 , VMiddle = 5 }
| basic position enum More...
enum | { LeftBit = 0x01 , RightBit = 0x02 , TopBit =0x4 , BottomBit = 0x08 , HMiddleBit = 0x10 , VMiddleBit = 0x20 }
| basic position enum bits More...
enum | NumberingType { NONE , BULLET , ARABIC , LOWERCASE , UPPERCASE , LOWERCASE_ROMAN , UPPERCASE_ROMAN }
enum | WritingMode { WritingLeftTop , WritingLeftBottom , WritingRightTop , WritingRightBottom , WritingInherited }
| the different writing mode More...
enum | SubDocumentType { DOC_NONE , DOC_CHART , DOC_CHART_ZONE , DOC_COMMENT_ANNOTATION , DOC_GRAPHIC_GROUP , DOC_HEADER_FOOTER , DOC_NOTE , DOC_SHEET , DOC_TABLE , DOC_TEXT_BOX }

## Functions

uint8_t | readU8 (librevenge::RVNGInputStream *input)
void | appendUnicode (uint32_t val, librevenge::RVNGString &buffer)
| adds an unicode character to a string
std::string | numberingTypeToString (NumberingType type)
std::string | numberingValueToString (NumberingType type, int value)
std::string | writingModeToString (WritingMode mode)
| a function to convert a writing mode in string lt-rb, ...
bool | convertDTFormat (std::string const &dtFormat, librevenge::RVNGPropertyListVector &propVect)
| convert a DTFormat in a propertyList
MWAWVec2f | rotatePointAroundCenter (MWAWVec2f const &point, MWAWVec2f const &center, float angle)
| rotate a point around center, angle is given in degree
MWAWBox2f | rotateBoxFromCenter (MWAWBox2f const &box, float angle)
| rotate a bdox and returns the final bdbox, angle is given in degree
template<typename T>
bool | checkAddOverflow (T x, T y)
| checks whether addition of `x` and `y` would overflow
std::ostream & | operator<< (std::ostream &o, PrinterInfo const &r)
| operator<< for a PrinterInfo

## Variables

static uint32_t const | s_SJIS_encoding []
| SJIS conversion table: c,unicode[c].
static uint32_t const | s_SJIS_encoding2 []
| SJIS conversion table for code with 2 entries(actually, ignored): c,unicode[c],unicode[c1].

## Detailed Description

namespace used to regroup all libwpd functions, enumerations which we have redefined for internal usage

some basic tools

## Typedef Documentation

## DebugStream

typedef std::stringstream libmwaw::DebugStream

a basic stream (if debug_with_files is not defined, does nothing)

## Enumeration Type Documentation

## anonymous enum

anonymous enum

basic position enum bits

Enumerator
LeftBit |
RightBit |
TopBit |
BottomBit |
HMiddleBit |
VMiddleBit |

## NumberingType

enum libmwaw::NumberingType

Enumerator
NONE |
BULLET |
ARABIC |
LOWERCASE |
UPPERCASE |
LOWERCASE_ROMAN |
UPPERCASE_ROMAN |

## Position

enum libmwaw::Position

basic position enum

Enumerator
Left |
Right |
Top |
Bottom |
HMiddle |
VMiddle |

## SubDocumentType

enum libmwaw::SubDocumentType

Enumerator
DOC_NONE |
DOC_CHART |
DOC_CHART_ZONE |
DOC_COMMENT_ANNOTATION |
DOC_GRAPHIC_GROUP |
DOC_HEADER_FOOTER |
DOC_NOTE |
DOC_SHEET |
DOC_TABLE |
DOC_TEXT_BOX |

## WritingMode

enum libmwaw::WritingMode

the different writing mode

Enumerator
WritingLeftTop |
WritingLeftBottom |
WritingRightTop |
WritingRightBottom |
WritingInherited |

## Function Documentation

## appendUnicode()

void libmwaw::appendUnicode | ( | uint32_t | val,
|  | librevenge::RVNGString & | buffer )

adds an unicode character to a string

Referenced by MWAWTabStop::addTo(), ActaParser::getMainList(), MWAWCellContent::FormulaInstruction::getPropertyList(), MWAWGraphicListener::insertUnicode(), MWAWPresentationListener::insertUnicode(), MWAWSpreadsheetListener::insertUnicode(), MWAWTextListener::insertUnicode(), MoreText::readCustomListLevel(), MsWrdParser::readDocSum(), ClarisWksDocument::readDSUM(), RagTime5StructManager::readField(), Canvas5Parser::readFileRSRCs(), MultiplanParser::readFormula(), RagTime5Formula::readFormula(), StudentWritingCParser::readFrame(), MindWrtParser::readHeadingCustom(), Canvas5Parser::readLayers(), MacDrawProParser::readLayersInfo(), MacDraft5Parser::readLayoutDefinitions(), ClarisDrawParser::readLayouts(), MacDrawProParser::readLibrariesInfo(), MacDraft5Parser::readLibraryFooter(), ClarisDrawParser::readLibraryNames(), MultiplanParser::readLink(), MultiplanParser::readLinkFilename(), MsWks4Text::readParagraph(), PowerPoint3Parser::readParagraph(), MarinerWrtText::readRulers(), Canvas5Parser::readString(), CanvasParser::readString(), JazzWriterParser::readString(), MWAWOLEParser::readSummaryPropertyString(), PowerPoint7Text::readTextZone(), RagTime5StructManager::readUnicodeString(), ClarisWksPresentation::readZone1(), Canvas5Graph::sendCurveText(), Canvas5Graph::sendDimension(), CanvasGraph::sendDimension(), ClarisWksText::sendText(), MindWrtParserInternal::ZoneInfo::updateListId(), ClarisDrawTextInternal::Paragraph::updateListLevel(), ClarisWksTextInternal::Paragraph::updateListLevel(), and MoreTextInternal::Paragraph::updateToFinalState().

## checkAddOverflow()

template<typename T>

bool libmwaw::checkAddOverflow | ( | T | x,
|  | T | y )

checks whether addition of `x` and `y` would overflow

Referenced by MWAWVec2< bool >::add(), and MWAWVec2< bool >::operator-=().

## convertDTFormat()

bool libmwaw::convertDTFormat | ( | std::string const & | dtFormat,
|  | librevenge::RVNGPropertyListVector & | propVect )

convert a DTFormat in a propertyList

Referenced by MWAWField::addTo(), and MWAWCell::Format::getNumberingProperties().

## numberingTypeToString()

std::string libmwaw::numberingTypeToString | ( | NumberingType | type | ) |

Referenced by NisusWrtParserInternal::Variable::operator<<.

## numberingValueToString()

std::string libmwaw::numberingValueToString | ( | NumberingType | type,
|  | int | value )

Referenced by NisusWrtParser::getReferenceData().

## operator<<()

std::ostream & libmwaw::operator<< | ( | std::ostream & | o,
|  | PrinterInfo const & | r )

operator<< for a PrinterInfo

## readU8()

uint8_t libmwaw::readU8 | ( | librevenge::RVNGInputStream * | input | ) |

## rotateBoxFromCenter()

MWAWBox2f libmwaw::rotateBoxFromCenter | ( | MWAWBox2f const & | box,
|  | float | angle )

rotate a bdox and returns the final bdbox, angle is given in degree

Referenced by MacDrawProParserInternal::Shape::getBdBox(), BeagleWksDRParser::sendPictures(), and GreatWksGraph::sendTextboxAsGraphic().

## rotatePointAroundCenter()

MWAWVec2f libmwaw::rotatePointAroundCenter | ( | MWAWVec2f const & | point,
|  | MWAWVec2f const & | center,
|  | float | angle )

rotate a point around center, angle is given in degree

Referenced by MacDraft5Parser::readObject(), and rotateBoxFromCenter().

## writingModeToString()

std::string libmwaw::writingModeToString | ( | WritingMode | mode | ) |

a function to convert a writing mode in string lt-rb, ...

Referenced by MWAWParagraph::addTo(), and MWAWParagraph::operator<<.

## Variable Documentation

## s_SJIS_encoding

uint32_t const libmwaw::s_SJIS_encoding[]

static

SJIS conversion table: c,unicode[c].

Referenced by MWAWFontSJISConverter::initMap().

## s_SJIS_encoding2

uint32_t const libmwaw::s_SJIS_encoding2[]

static

Initial value:
= {
0x82F5,0x304B,0x309A, 0x82F6,0x304D,0x309A, 0x82F7,0x304F,0x309A, 0x82F8,0x3051,0x309A, 0x82F9,0x3053,0x309A,
0x8397,0x30AB,0x309A, 0x8398,0x30AD,0x309A, 0x8399,0x30AF,0x309A, 0x839A,0x30B1,0x309A, 0x839B,0x30B3,0x309A,
0x839C,0x30BB,0x309A, 0x839D,0x30C4,0x309A, 0x839E,0x30C8,0x309A, 0x83F6,0x31F7,0x309A, 0x8663,0x00E6,0x0300,
0x8667,0x0254,0x0300, 0x8668,0x0254,0x0301, 0x8669,0x028C,0x0300, 0x866A,0x028C,0x0301, 0x866B,0x0259,0x0300,
0x866C,0x0259,0x0301, 0x866D,0x025A,0x0300, 0x866E,0x025A,0x0301, 0x8685,0x02E9,0x02E5, 0x8686,0x02E5,0x02E9
}

SJIS conversion table for code with 2 entries(actually, ignored): c,unicode[c],unicode[c1].

Referenced by MWAWFontSJISConverter::initMap().